﻿

XIncludeFile "!pack.pbi"
XIncludeFile "!json.pbi"
XIncludeFile "!tools.pbi"

UsePNGImageDecoder()
UsePNGImageEncoder()
InitNetwork()
EnableExplicit

OpenConsole()
#iconsize=32


Global NewList MinecraftID.s()

Define server.s
Define java.s
Define game.s

CompilerIf #False ;Server-Report
  server=GetCurrentDirectory()+"work\server.jar"
  server=OpenFileRequester("select minecraft server",server,"java|*.jar|all|*.*",0)
  If server="" Or FileSize(server)<=0
    End
  EndIf
  java="F:\Minecraft\runtime\jre-x64\1.8.0_51\bin\java.exe"
  java=OpenFileRequester("Select Java Runtime",java,"java|java.exe|all|*.*",0)
  If java="" Or FileSize(java)<=0
    End
  EndIf
  
  ConsoleTitle("Export server data")
  CreateDirectory("datagen")
  CreateDirectory("datagen\reports")
  
  RunProgram(java,"-classpath "+#DQUOTE$+server+#DQUOTE$+" net.minecraft.data.Main --reports --all --output "+#DQUOTE$+GetCurrentDirectory()+"datagen"+#DQUOTE$,GetPathPart(server),#PB_Program_Wait)
  PrintN("")
  PrintN("")
CompilerEndIf


ConsoleTitle("Read minecraft ids")
ClearList(MinecraftID())
  
If json::open("datagen\reports\items.json")
  If json::Examine()
    While json::NextEntry()
      AddElement(MinecraftID())
      MinecraftID()=json::Entry
    Wend      
    json::Finish()
  EndIf
  json::Close()
EndIf
PrintN("Minecraft ids:"+ListSize(MinecraftID()))
PrintN("")

CompilerIf #False ;icons
  
ConsoleTitle("Generate icons")
  
game=GetEnvironmentVariable("appdata")+"\.minecraft\versions\"
game=OpenFileRequester("select minecraft version",game,"java|*.jar|all|*.*",0)
If game=""
  End
EndIf

Enumeration
  #ico_none
  #ico_itemgenerated
  #ico_cube_all
  #ico_block_stairs
  #ico_block_slab
  #ico_thin_block
  #ico_endrod
  #ico_ignore  
EndEnumeration

Define img1,img2,i
Define icon.s,ok,type
Define *data
Define w,h
Define tex_top.s,tex_left.s,tex_right.s
Global NewMap Texture.s()
Procedure.s GetTexture(key.s)
  Protected str.s
  Repeat
    If FindMapElement(texture(),key)
      str=texture()
      If Left(texture(),1)="#"
        key=Mid(texture(),2)
        str=""
      EndIf
    Else
      Break
    EndIf
  Until str<>""
  ProcedureReturn str
EndProcedure

Procedure DownloadWiki(icon.s,dest.s)
  Protected *buf,side.s,a,link.s,b
  Protected img,w,h,ret,img2
  If icon="player_head"
    icon="head"
  EndIf
  *buf=ReceiveHTTPMemory("https://minecraft.gamepedia.com/File:"+_ucase(icon)+".png")
  
  side= PeekS(*buf,-1,#PB_UTF8)
  
  a=0
  Repeat
    a=FindString(side,~"href=\"https://",a)
    If a
      a+6
      b=FindString(side,#DQUOTE$,a+1)
      link=Mid(side,a,b-a)
      
      If FindString(link,"thumb")=0 And FindString(link,".png")>0 And FindString(link,"?version")>0
        Break
      EndIf
      
    Else
      link=""
      Break
      
    EndIf
  ForEver
  
  FreeMemory(*buf)
  
  If link
    *buf=ReceiveHTTPMemory(link)
    If *buf
      img=CatchImage(#PB_Any,*buf)
      If img
        w=ImageWidth(img)*#iconsize/ImageHeight(img)
        h=#iconsize
        If w>#iconsize
          w=#iconsize
          h=ImageWidth(img)*#iconsize/ImageWidth(img)
        EndIf
        
        ResizeImage(img,w,h,#PB_Image_Smooth)
        
        img2=CreateImage(#PB_Any,#iconsize,#iconsize,32,#PB_Image_Transparent)
        StartDrawing(ImageOutput(img2))
        DrawingMode(#PB_2DDrawing_AlphaBlend)
        DrawAlphaImage(ImageID(img),(#iconsize-w)/2,(#iconsize-h)/2)
        StopDrawing()
        
        
        SaveImage(img2,dest,#PB_ImagePlugin_PNG)
        FreeImage(img)
        FreeImage(img2)
        ret=#True
      EndIf
      
      FreeMemory(*buf)
      
    EndIf
    
  EndIf
    ProcedureReturn ret
    
EndProcedure    

Define str.s,out.s


CreateDirectory("datagen\icons")

pack::Open(game)
ForEach MinecraftID()
  PrintN(MinecraftID())
  ;Debug "nextId:"+MinecraftID()
  
  
;   While FileSize("icons\"+StringField(MinecraftID(),2,":")+".png")>0
;     Debug "jump:"+MinecraftID()
;     If NextElement(MinecraftID())=#False
;       Break
;     EndIf
;   Wend
;   
  
  
  
  ;Debug MinecraftID()
  icon=StringField(MinecraftID(),2,":")
  ok=#False
  ClearMap(texture())
  str="item/"+icon
  type=#ico_none
  
  
    ;Debug "generate:"+icon
    
    out=""
    ;Debug "--- start"
    
    If MinecraftID()="minecraft:air" 
      img1=CreateImage(#PB_Any,16,16)
      ok=#True
      str=""
    EndIf
    
    Repeat
      If str<>"" And json::Pack("assets/minecraft/models/"+str+".json")
        ;Debug "---------------- "+str
        out+#LF$+ json::Output()
        If json::Examine("textures")
          
          While json::NextEntry()
            texture(json::Entry)=json::GetString()          
          Wend  
          
          
          json::Finish()
        EndIf
        
        str=json::getstring("parent")
        
        If type=#ico_none
          Select str
            Case "item/generated","builtin/generated":type=#ico_itemgenerated
            Case "builtin/entity","item/air","block/anvil","block/end_rod",
                 "block/template_orientable_trapdoor_bottom","block/pressure_plate_up"
              type=#ico_ignore
            Case "block/cube_all","block/cube","block/cube_directional","block/block":type=#ico_cube_all
            Case "block/stairs":type=#ico_block_stairs
            Case "block/slab":type=#ico_block_slab
            Case "block/thin_block":type=#ico_thin_block   
          EndSelect
        EndIf
        
        
        json::close()
        
      Else
        
        Define off
        
        Select type
          Case #ico_block_slab
            ;{ slab
            img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ gettexture("side")+".png"))
            w=ImageWidth(img2)
            h=ImageHeight(img2)
            img1=CreateImage(#PB_Any,w*2,h*2,32, #PB_Image_Transparent )
            
            StartDrawing(ImageOutput(img1))
            DrawingMode(#PB_2DDrawing_AlphaBlend)
            
            ClipOutput(w/4,h/2+H/4+h/2,w,h/2)
            DrawAlphaImage(ImageID(img2),0+w/4,h/2+h/4)
            ;FreeImage(img2)
            
            ;img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ gettexture("side")+".png"))
            ResizeImage(img2,w/2,h,#PB_Image_Raised)
            For I=0 To w-1
              ClipOutput(w+(w-1-i)/2+w/4,i/2+h/4+h/2 , 1,h/2)
              DrawAlphaImage(ImageID(img2),w+w/4,i/2+h/4,192)
            Next
            FreeImage(img2)
            
            img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ gettexture("top")+".png"))
            ResizeImage(img2,w,h/2,#PB_Image_Raised)
            For I=0 To h-1
              ClipOutput(i/2 +w/4 ,(h-1-i)/2+h/4+h/2,w,1)
              DrawAlphaImage(ImageID(img2),i/2 +w/4,h/4+h/2,128)
            Next
            FreeImage(img2)
            StopDrawing()            
            
            ok=#True
            ;}
            
          Case #ico_block_stairs  
            ;{ stairs
            img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ gettexture("side")+".png"))
            w=ImageWidth(img2)
            h=ImageHeight(img2)
            img1=CreateImage(#PB_Any,w*2,h*2,32, #PB_Image_Transparent )
            
            StartDrawing(ImageOutput(img1))
            DrawingMode(#PB_2DDrawing_AlphaBlend)
            
            ClipOutput(w/4,h/2+H/4,w/2,h)
            DrawAlphaImage(ImageID(img2),0+w/4,h/2+h/4)
            ClipOutput(w/4+w/2,h/2+H/4+h/2,w/2,h/2)
            DrawAlphaImage(ImageID(img2),0+w/4,h/2+h/4)
            ;FreeImage(img2)
            
            ;img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ gettexture("side")+".png"))
            ResizeImage(img2,w/2,h,#PB_Image_Raised)
            For I=0 To w-1
              ClipOutput(w+(w-1-i)/2+w/4,i/2+h/4+h/2 , 1,h/2)
              DrawAlphaImage(ImageID(img2),w+w/4,i/2+h/4,192)
              
              ClipOutput(w+(w-1-i)/2+w/4 -w/2,i/2+h/4 , 1,h/2)
              DrawAlphaImage(ImageID(img2),w+w/4-w/2,i/2+h/4,192)
              
            Next
            FreeImage(img2)
            
            img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ gettexture("top")+".png"))
            ResizeImage(img2,w,h/2,#PB_Image_Raised)
            For I=0 To h-1
              ClipOutput(i/2 +w/4 ,(h-1-i)/2+h/4,w/2,1)
              DrawAlphaImage(ImageID(img2),i/2 +w/4,h/4,128)
              
              ClipOutput(i/2 +w/4+w/2 ,(h-1-i)/2+h/4+h/2,w/2,1)
              DrawAlphaImage(ImageID(img2),i/2 +w/4+w/2,h/4+h/2,128)
            Next
            FreeImage(img2)
            StopDrawing()

            ok=#True
            ;}
                        
          Case #ico_cube_all
            ;{ cube
            tex_left=GetTexture("north")
            tex_top=GetTexture("up")
            tex_right=GetTexture("east")
            
            If tex_left="" Or tex_top="" Or tex_right=""
              tex_left=GetTexture("front")
              tex_top=GetTexture("top")
              tex_right=GetTexture("side")
              If tex_left="" 
                tex_left=tex_right
              EndIf
            EndIf          
            
            If tex_left="" Or tex_top="" Or tex_right=""
              tex_left=GetTexture("pattern")
              tex_top=tex_left
              tex_right=tex_left
            EndIf
            
            If tex_left="" Or tex_top="" Or tex_right=""
              tex_left=GetTexture("dirt")
              tex_top=GetTexture("top")
              tex_right=GetTexture("dirt")
            EndIf   
            
            If tex_left<>"" And tex_top<>"" And tex_right<>""
              img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ tex_left+".png"))
              w=ImageWidth(img2)
              h=ImageHeight(img2)
              img1=CreateImage(#PB_Any,w*2,h*2,32, #PB_Image_Transparent )
              
              StartDrawing(ImageOutput(img1))
              DrawingMode(#PB_2DDrawing_AlphaBlend)
              
              DrawAlphaImage(ImageID(img2),0+w/4,h/2+h/4)
              FreeImage(img2)
              
              img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ tex_top+".png"))
              ResizeImage(img2,w,h/2,#PB_Image_Raised)
              For I=0 To h-1
                ClipOutput(i/2 +w/4,(h-1-i)/2+h/4,w,1)
                DrawAlphaImage(ImageID(img2),i/2+w/4,0+h/4,128)
              Next
              FreeImage(img2)
              
              img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ tex_right+".png"))
              ResizeImage(img2,w/2,h,#PB_Image_Raised)
              For I=0 To w-1
                ClipOutput(w+(w-1-i)/2+w/4,i/2+h/4, 1,h)
                DrawAlphaImage(ImageID(img2),w+w/4,i/2+h/4,192)
              Next
              FreeImage(img2)
              StopDrawing()
              ok=#True

              
            EndIf
            ;}
            
          Case #ico_thin_block
            ;{ Thin
            ForEach Texture()
              If Left(texture(),1)<>"#" And texture()<>"particle"
                tex_top=texture()
                Break
              EndIf
            Next
            If tex_top<>""
              img2=CatchImage(#PB_Any,pack::GetFile("assets/minecraft/textures/"+ tex_top+".png"))
              w=ImageWidth(img2)
              h=ImageHeight(img2)
              img1=CreateImage(#PB_Any,w*2,h*2,32, #PB_Image_Transparent )
              
              StartDrawing(ImageOutput(img1))
              DrawingMode(#PB_2DDrawing_AlphaBlend)
              
              ResizeImage(img2,w,h/2,#PB_Image_Raised)
              For I=0 To h-1
                ClipOutput(i/2 +w/4,(h-1-i)/2+h/4+h,w,1)
                DrawAlphaImage(ImageID(img2),i/2+w/4,0+h/4+h,128)
              Next
              
              FreeImage(img2)
              StopDrawing()
              
              ok=#True
              
            EndIf
            ok=#True
            ;}
            
          Case #ico_itemgenerated
            ;{ itemgenerated
            *data=pack::GetFile("assets/minecraft/textures/"+ gettexture("layer0")+".png")
            If *data
              img1=CatchImage(#PB_Any,*data)            
              i=0
              StartDrawing(ImageOutput(img1))
              DrawingMode(#PB_2DDrawing_AlphaBlend )  
              Repeat
                i+1
                
                *Data=pack::GetFile("assets/minecraft/textures/"+ gettexture("layer"+i)+".png")
                If *data=#Null
                  Break
                EndIf
                
                img2=CatchImage(#PB_Any,*data)
                If img2=#Null
                  Break
                EndIf
                
                
                
                DrawAlphaImage(ImageID(img2),0,0)
                
                FreeImage(img2)   
                
              ForEver
              StopDrawing()
              ok=#True
                            
            EndIf
            ;}
            
          Case #ico_ignore
            ;Debug "Missing:"+icon
            ;DownloadWiki(icon,icon+".png")
            
           
        EndSelect
        
        If ok And IsImage(img1)
          ResizeImage(img1,#iconsize,#iconsize,#PB_Image_Raw)
          SaveImage(img1,"datagen\icons\"+icon+".png",#PB_ImagePlugin_PNG)
          FreeImage(img1)
        Else
          Debug "MissigIcon:"+icon
          If FileSize("datagen\icons\"+icon+".png")>0 Or DownloadWiki(icon,"datagen\icons\"+icon+".png")
            Debug "...downloaded"
          Else
            Debug out
            CallDebugger
          EndIf
        EndIf          
        img1=0
        
        Break
      EndIf      
      
    ForEver
    
  
Next

PrintN("done")
PrintN("")

Debug "OK"

pack::Close()
CompilerEndIf

Structure sLanguage
  file.s
  name.s
  id.s
  region.s
  notComplete.i
  Map MineId.s()
EndStructure

  

NewList language.sLanguage()
ConsoleTitle("Localization")

Define index.s

index=GetEnvironmentVariable("appdata")+"\.minecraft\assets\indexes\1.13.json"
index=OpenFileRequester("select minecraft index file",index,"java|*.json|all|*.*",0)

If json::Open(index)
  If json::Examine("objects")
    While json::NextEntry()      
      If IsLeft(json::@Entry,@"minecraft/lang/")
        AddElement(language())
        language()\file=json::GetString("hash")
      EndIf      
    Wend
    json::Finish()
  EndIf
  json::Close()
EndIf

Define objects.s,str.s,str2.s
objects=GetEnvironmentVariable("appdata")+"\.minecraft\assets\objects\"

ForEach language()
  If json::open(objects+Left(language()\file,2)+"\"+language()\file)
    
    language()\id=json::GetString("language.code")
    language()\name=json::GetString("language.name")
    language()\region=json::GetString("language.region")
    
    Select language()\id
      Case "ksh_de" : language()\id="de_ksh"
      Case "alg_de" : language()\id="de_alg"
      Case "sxu_de" : language()\id="de_sxu"
      Case "ca-val_ES" : language()\id="ca_ES-val"        
    EndSelect
    
    ForEach MinecraftID()
      str=json::GetString("item.minecraft."+StringField(MinecraftID(),2,":"))
      If str<>""
        str2=json::GetString("item.minecraft."+StringField(MinecraftID(),2,":")+".desc")
        If str2<>""
          str+" "+str2
        EndIf
      Else            
        str=json::GetString("block.minecraft."+StringField(MinecraftID(),2,":"))
      EndIf        
      If str=""
        language()\notComplete+1
        str=StringField(MinecraftID(),2,":")
        ;DeleteElement( language() )
        ;Break
      EndIf
      
      language()\MineId(MinecraftID())=str
      
    Next
    json::Close()
  EndIf
  If language()\notComplete>50
    DeleteElement(language())
  EndIf
Next




ConsoleTitle("Generate categories")
Define dirCat,str.s,cat.s,dir
NewMap category.s()
#path="datagen\data\minecraft\advancements\recipes\"

dirCat=ExamineDirectory(#PB_Any,#path,"*.*")
If dirCat
  While NextDirectoryEntry(dirCat)
    cat=DirectoryEntryName(dirCat)
    If cat<>"." And cat<>".." And DirectoryEntryType(dirCat)=#PB_DirectoryEntry_Directory
      
      dir=ExamineDirectory(#PB_Any,#path+cat+"\","*.json")
      While NextDirectoryEntry(dir)
        str=DirectoryEntryName(dir)
        If DirectoryEntryType(dir)=#PB_DirectoryEntry_File
          If json::open(#path+cat+"\"+str)
            If json::OpenSub("rewards")
              If json::OpenArray("recipes")
                While json::NextArrayEntry()
                  category(json::GetString())=cat
                Wend
                json::CloseArray()
              EndIf
              json::CloseSub()
            EndIf
            json::Close()
          EndIf
        EndIf
      Wend
      FinishDirectory(dir)
      
      
    EndIf
  Wend
  FinishDirectory(dirCat)
EndIf
Debug "---"

Define *buf
Define pack


ConsoleTitle("pack file")

pack=CreatePack(#PB_Any,"work\minecraft_vanilla.zip",#PB_PackerPlugin_Zip,9)

If json::new()
  ForEach MinecraftID()
    If json::CreateSub(MinecraftID())
      
      If FindMapElement(category(),MinecraftID())
        json::SetString("category",category())
      Else
        json::SetString("category","collected")
      EndIf
      
      *buf=LoadFile("datagen\icons\"+StringField(MinecraftID(),2,":")+".png")
      If *buf
        If json::CreateSub("icon")
          json::SetInteger("size",MemorySize(*buf))
          json::SetString("base64",Base64Encoder(*buf,MemorySize(*buf)))
          json::CloseSub()
        EndIf
        FreeMemory(*buf)        
      EndIf 
      
      json::CloseSub()
    EndIf
  Next
  
  PrintN("pack ids & icons")
  ;Debug json::Output()
  *buf=json::Export()
  If *buf
    AddPackMemory(pack,*buf,MemorySize(*buf),"minecraft-ids.json")
    FreeMemory(*buf)
  EndIf
  json::Close()
  
  
  PrintN("pack recipes")
  #path_recipe="datagen\data\minecraft\recipes\"
  dir=ExamineDirectory(#PB_Any,#path_recipe,"*.json")
  If dir
    While NextDirectoryEntry(dir)
      str=DirectoryEntryName(dir)
      AddPackFile(pack,#path_recipe+str,"recipes/"+str)
    Wend
    FinishDirectory(dir)
  EndIf
  
  PrintN("pack tags")
  #path_tags="datagen\data\minecraft\tags\items\"
  dir=ExamineDirectory(#PB_Any,#path_tags,"*.json")
  If dir
    While NextDirectoryEntry(dir)
      str=DirectoryEntryName(dir)
      AddPackFile(pack,#path_tags+str,"tags/"+str)
    Wend
    FinishDirectory(dir)
  EndIf
  
  PrintN("pack lang")
  
  NewMap mainLang.s()
  ForEach language()
    str=StringField(language()\id,1,"_")
    mainLang( str )=str
  Next
  
  NewMap words()
  Define maxWord
  
  If json::New()
    If json::CreateSub("id")
      ForEach language()
        If json::CreateSub(language()\id)
          json::SetString("name",language()\name)
          json::SetString("region",language()\region)        
          json::CloseSub()        
        EndIf
      Next
      json::CloseSub()
    EndIf
    If json::createsub("items")
      ForEach MinecraftID()
        
        
        If json::CreateSub( MinecraftID() )
          
          ForEach mainLang()
            ClearMap(words())
            maxWord=-1
            
            ForEach language()
              If language()\id=mainLang()+"_"+mainLang()
                str=language()\MineId( MinecraftID() ) 
                Break
              EndIf
              
              If StringField(language()\id,1,"_") = mainLang()
                words( language()\MineId( MinecraftID() ) ) +1
                If words()>maxWord 
                  maxWord=words()
                  str=language()\MineId()
                EndIf
              EndIf
            Next
            
            json::SetString(mainLang(),str )
            
            ForEach language()
              If StringField(language()\id,1,"_")=mainLang()
                If language()\MineId( MinecraftID() ) <> str
                  json::SetString(language()\id, language()\MineId() )
                EndIf
              EndIf
            Next
          Next  
          json::CloseSub()
        EndIf
        
      
      Next
      json::CloseSub()
      
     
      
    EndIf
          
    *buf=json::Export()
    If *buf
      AddPackMemory(pack,*buf,MemorySize(*buf),"language.json")
      FreeMemory(*buf)
    EndIf
    
    json::close()
  EndIf
  pack::Close()
  
  
  
EndIf

PrintN("")

PrintN("Press enter")

Input()

CloseConsole()

; IDE Options = PureBasic 5.62 (Windows - x86)
; ExecutableFormat = Console
; CursorPosition = 611
; FirstLine = 143
; Folding = I9
; EnableXP
; UseIcon = if_Settings_1891011.ico
; Executable = DataGen.exe