﻿
XIncludeFile "!pack.pbi"
XIncludeFile "!json.pbi"
XIncludeFile "!tools.pbi"
XIncludeFile "!noany.pbi"
XIncludeFile "!CanList.pbi"

Global LoadedLangId.s="de_de"


UsePNGImageDecoder()
UsePNGImageEncoder()
InitNetwork()
EnableExplicit

#title="Recipe Generator"
#version="0.92 BETA"

#recipe_Smelting="smelting"
#recipe_crafting_shaped="crafting_shaped"
#recipe_crafting_shapeless="crafting_shapeless"

#grid_width=100
#grid_height=100

Structure sMineId
  id.s
  icon.i
  lang.s
  isTag.i
  hasRecipe.i
  isIngredient.i
EndStructure
Structure sTags Extends sMineId
  replace.i
  List values.s()
  List *idlink.sMineId()
EndStructure

Structure sCategory
  List *id.sMineId()
EndStructure

Structure sKeyChar
  key.s
  List item.s()
EndStructure
Structure sResult
  item.s
  count.i
EndStructure
Structure sIngredients
  List item.s()
EndStructure

Structure sRecipe
  type.s
  group.s
  pattern.s[3]
  List key.sKeyChar()
  List ingredients.sIngredients()
  result.sResult
  experience.d
  cookingtime.i  
  trigger.s
EndStructure

Structure sLangId
  id.s
  mainid.s
  name.s
  region.s
EndStructure

Structure sMineRecipe
  name.s
  recipe.sRecipe
EndStructure

Global NewList MineRecipe.sMineRecipe()
Global NewList CostumRecipe.sMineRecipe()

Global NewList MineTags.sTags()
Global NewList MineID.sMineId()
Global NewMap Category.sCategory()
Global NewList LangId.sLangId()

Procedure LoadMinecraftIds()
  Protected str.s,size,*buf,base64.s
  ClearList(MineID())
  
  If json::pack("minecraft-ids.json")
    If json::Examine()
      While json::NextEntry()
        If json::OpenSub()
          AddElement(MineID())
          MineID()\id=json::Entry
          MineID()\lang=StringField(json::Entry,2,":")
          If json::OpenSub("icon")
            size=json::GetInteger("size")
            base64=json::GetString("base64")
            *buf=AllocateMemory(size)
            If *buf
              Base64Decoder(base64,*buf,size)
              CatchImage(MineID()\icon,*buf,size)
              FreeMemory(*buf)
            EndIf
            
            json::CloseSub()
          EndIf
          
          str=json::GetString("category","collected")
          Category(str)
          AddElement(Category()\id())
          category()\id()=@MineID()
          
          json::CloseSub()
        EndIf
        
      Wend      
      json::Finish()
    EndIf
    
    json::Close()
  EndIf
  
  Category("all")
  ForEach MineID()
    AddElement(Category()\id())
    category()\id()=@MineID()
  Next
  
EndProcedure
Procedure findMinecraftID(id.s)
  Protected ret
  If Left(id,1)="#"
    ForEach MineTags()
      If MineTags()\id=id
        ret=minetags()
        Break
      EndIf
    Next
  Else    
    ForEach MineID()
      If MineID()\id=id
        ret=mineid()
        Break
      EndIf
    Next
  EndIf
  ProcedureReturn ret
EndProcedure

Procedure BuildTagIdLink(*scan.sTags,*store.stags)
  Protected *id.sMineId
  ForEach *scan\values()
    *id=findMinecraftID(*scan\values())
    If *id\isTag
      BuildTagIdLink(*id,*store)
    Else      
      AddElement(*store\idlink())
      *store\idlink()=*id
    EndIf
  Next
  
EndProcedure

Procedure LoadMinecraftTags()
  Protected json,name.s
  Protected object,i
  Protected sub, arr
  
  Category("#Tags")
          
  
  ClearList(MineTags())
  If pack::Examine("tags/")
    While pack::Examine()
      name=pack::GetFileName()
      If name=""
        Break
      EndIf
      If Right(name,5)=".json"
        If name<>""
          AddElement(MineTags())
          MineTags()\id="#minecraft:"+Mid(name,6,Len(name)-5-5)
          MineTags()\lang="#"+StringField(MineTags()\id,2,":")
          MineTags()\isTag=#True
          
          AddElement(Category()\id())
          category()\id()=@MineTags()
          
          If json::Pack(name)
            MineTags()\replace=json::GetBool("replace")
            
            
            json::GetStringList("values",MineTags()\values())
            
            json::Close()
            
          EndIf
          
          
        EndIf
      EndIf      
    Wend    
  EndIf
  
  Protected *dat.stags,str.s
  
  ForEach MineTags()
    PushListPosition(MineTags())
    BuildTagIdLink(MineTags(),MineTags())
    PopListPosition(MineTags())
  Next
EndProcedure
Procedure LoadLanguage(id.s)
  Protected mainId.s=StringField(id,1,"_")
  If json::pack("language.json")
    If json::OpenSub("items")
      ForEach mineid()
        If json::OpenSub( MineID()\id )        
          MineID()\lang =Trim( json::GetString( id,  json::GetString(mainId, StringField(MineID()\id,2,":") ) ))
          json::CloseSub()
        EndIf          
      Next
      json::CloseSub()
    EndIf
    json::Close()
  EndIf
EndProcedure

Procedure LoadLangId()
  ClearList(LangId())
  If json::Pack("language.json")
    If json::Examine("id")
      While json::NextEntry()
        AddElement(LangId())
        LangId()\id=json::Entry
        LangId()\mainid=StringField(json::Entry,1,"_")
        LangId()\name=json::GetString("name")
        LangId()\region=json::GetString("region")
      Wend
      json::Finish()
    EndIf
    json::close()
  EndIf
  SortStructuredList(LangId(),#PB_Sort_Ascending,OffsetOf(sLangId\id),#PB_String)
  ResetList(LangId())
  AddElement(LangId())
  LangId()\id="mine_mine"
  langid()\name="Minecraft IDs"
  LangId()\region=""
  LangId()\mainid="mine"
  
  
EndProcedure

Procedure GetJsonRecipe(*recipe.sRecipe)
  Protected x,y,str.s
  ResetStructure(*recipe,sRecipe)
  
  *recipe\type  = json::GetString("type")
  *recipe\group = json::GetString("group")
  
  If json::OpenArray("pattern")
    y=0
    While json::NextArrayEntry()
      *recipe\pattern[y]=json::GetString()
      y+1
    Wend
    json::CloseArray()
  EndIf
  
  If json::Examine("key")
    While json::NextEntry()
      AddElement( *recipe\key() )
      *recipe\key()\key = json::Entry
      
      If json::OpenArray()
        While json::NextArrayEntry()
          str=json::GetString("item")
          If str=""
            str="#"+json::getstring("tag")
          EndIf
          AddElement(*recipe\key()\item())
          *recipe\key()\item() = str
        Wend      
        json::CloseArray()
      EndIf
      
    Wend
    json::Finish()
    
  EndIf
  
  If json::OpenArray("ingredients") Or json::OpenArray("ingredient")
    While json::NextArrayEntry()
      AddElement(*recipe\ingredients())
      If json::OpenArray()
        While json::NextArrayEntry()
          str=json::GetString("item")
          If str=""
            str="#"+json::getstring("tag")
          EndIf
          AddElement(*recipe\ingredients()\item())
          *recipe\ingredients()\item()=str
        Wend
        json::CloseArray()
      EndIf
    Wend
    json::CloseArray()
  EndIf
  
  If *recipe\type=#recipe_Smelting
    *recipe\result\item=json::GetString("result")
  Else
    If json::OpenSub("result")
      *recipe\result\item=json::GetString("item")
      *recipe\result\count=json::GetInteger("count",1)  
      json::CloseSub()
    EndIf
  EndIf
  
  *recipe\experience=json::GetDouble("experience")
  *recipe\cookingtime=json::GetInteger("cookingtime")
EndProcedure

Procedure SetTagItem(text.s)
  If Left(text,1)="#"
    ProcedureReturn json::SetString("tag", Mid(text,2))
  Else
    ProcedureReturn json::SetString("item",text)
  EndIf
EndProcedure

Procedure CreateJsonRecipe(*recipe.sRecipe)
  If json::New()=#False
    ProcedureReturn #False
  EndIf
  
  json::SetString("type",*recipe\type)
  
  If *recipe\group
    json::SetString("group",*recipe\group)
  EndIf
  
  ;{ Ingredients
  Select *recipe\type
    Case #recipe_crafting_shaped
      If json::CreateArray("pattern")
        json::AddArrayEntry()
        json::SetString("",*recipe\pattern[0])
        If *recipe\pattern[1]<>"" Or *recipe\pattern[2]<>""
          json::AddArrayEntry()
          json::SetString("",*recipe\pattern[1])
        EndIf
        If *recipe\pattern[2]<>""
          json::AddArrayEntry()
          json::SetString("",*recipe\pattern[2])
        EndIf
        json::CloseArray()
      EndIf
      
      If json::CreateSub("key")
         ForEach *recipe\key()
           
           If ListSize(*recipe\key()\item())=1
             If json::CreateSub(*recipe\key()\key)
               FirstElement(*recipe\key()\item())
               SetTagItem(*recipe\key()\item())
               json::CloseSub()
             EndIf
           Else
             If json::CreateArray(*recipe\key()\key)
               ForEach *recipe\key()\item()
                 json::AddArrayEntry()
                 SetTagItem(*recipe\key()\item())
               Next  
               json::CloseArray()
             EndIf
           EndIf
         Next
        
        json::CloseSub()
      EndIf
        
      
    Case #recipe_crafting_shapeless      
      If json::CreateArray("ingredients")
        ForEach *recipe\ingredients()
          json::AddArrayEntry()
          If ListSize(*recipe\ingredients()\item())=1
            FirstElement(*recipe\ingredients()\item())
            SetTagItem(*recipe\ingredients()\item())            
          Else
            If json::CreateArray()
              ForEach *recipe\ingredients()\item()
                json::AddArrayEntry()
                SetTagItem(*recipe\ingredients()\item())
              Next  
              json::CloseArray()
            EndIf
          EndIf
        Next
        
        json::CloseArray()
      EndIf
      
    Case #recipe_Smelting
      If ListSize(*recipe\ingredients())=1
        FirstElement(*recipe\ingredients())
        If json::CreateSub("ingredient")
          If ListSize(*recipe\ingredients()\item())=1
            FirstElement(*recipe\ingredients()\item())
            SetTagItem(*recipe\ingredients()\item()) 
          Else
            If json::CreateArray()
              ForEach *recipe\ingredients()\item()
                json::AddArrayEntry()
                SetTagItem(*recipe\ingredients()\item())
              Next  
              json::CloseArray()
            EndIf
          EndIf
          json::CloseSub()
        EndIf
      Else
        If json::CreateArray("ingredient")
          ForEach *recipe\ingredients()
            json::AddArrayEntry()
            If ListSize(*recipe\ingredients()\item())=1
              FirstElement(*recipe\ingredients()\item())
              SetTagItem(*recipe\ingredients()\item())            
            Else
              If json::CreateArray()
                ForEach *recipe\ingredients()\item()
                  json::AddArrayEntry()
                  SetTagItem(*recipe\ingredients()\item())
                Next  
                json::CloseArray()
              EndIf
            EndIf
          Next
          
          json::CloseArray()
        EndIf
      EndIf
      
  EndSelect
  ;}
  
  Select *recipe\type
    Case #recipe_crafting_shaped,#recipe_crafting_shapeless
      If json::CreateSub("result")
        json::SetString("item",*recipe\result\item)
        If *recipe\result\count>1
          json::SetInteger("count",*recipe\result\count)
        EndIf
        json::CloseSub()
      EndIf
      
    Case #recipe_Smelting
      json::SetString("result",*recipe\result\item)
      
      json::SetDouble("experience",*recipe\experience)
      json::SetInteger("cookingtime",*recipe\cookingtime)
      
  EndSelect
  
  ProcedureReturn #True
EndProcedure

Procedure LoadRecipes()
  Protected file.s
  Protected *id.sTags
  If pack::Examine("recipes/")
    While pack::Examine()
      file=pack::GetFileName()
      If json::Pack()
        AddElement(MineRecipe())
        MineRecipe()\name=Mid(file,9)
        GetJsonRecipe(MineRecipe()\recipe)
        json::Close()
      EndIf
    Wend
  EndIf
  
  ForEach MineRecipe()
    If MineRecipe()\recipe\type <> #recipe_crafting_shaped And 
       MineRecipe()\recipe\type <> #recipe_crafting_shapeless And 
       MineRecipe()\recipe\type <> #recipe_Smelting
      DeleteElement(MineRecipe())
    Else      
      If findMinecraftID(MineRecipe()\recipe\result\item)
        MineID()\hasRecipe=#True
      EndIf  
    EndIf
  Next
  
  Category(#recipe_Smelting)
  ForEach MineRecipe()
    If MineRecipe()\recipe\type=#recipe_Smelting
      AddElement(Category()\id())
      Category()\id()=findMinecraftID( MineRecipe()\recipe\result\item )
    EndIf
  Next
  
  ForEach MineRecipe()
    ForEach MineRecipe()\recipe\ingredients()
      ForEach MineRecipe()\recipe\ingredients()\item()
        *id=findMinecraftID(MineRecipe()\recipe\ingredients()\item())
        If *id\isTag
          ForEach *id\idlink()
            *id\idlink()\isIngredient=#True
          Next
        Else
          *id\isIngredient=#True
        EndIf
      Next
    Next
    ForEach MineRecipe()\recipe\key()
      ForEach MineRecipe()\recipe\key()\item()
        *id=findMinecraftID(MineRecipe()\recipe\key()\item())
        If *id\isTag
          ForEach *id\idlink()
            *id\idlink()\isIngredient=#True
          Next
        Else
          *id\isIngredient=#True
        EndIf
      Next
    Next
  Next
  
  
  pack::Close()
EndProcedure

;-
;- Load vanilla
;-
If pack::open("minecraft_vanilla.zip")
  
  LoadMinecraftIds()
  LoadMinecraftTags()
  LoadLangId()
  LoadRecipes()
  
  pack::close()
EndIf
;-
;- Menu
;-
Enumeration menu
  #men_saveDataPack
  #men_loadDataPack
  
  #men_importVanilla
  
  #men_NewRecipe
  #men_OverwriteRecipe
  #men_openRecipe
  #men_RemoveRecipe
    
  #men_recipeExport
  #men_recipeImport
  
  #men_RecipeTitle
  #men_recipe
  #men_lastrecipe=#men_recipe+100
  #men_OverwriteMineRecipe
  #men_lastOverwriteMineRecipe=#men_OverwriteMineRecipe+100
  
  #men_langstart
EndEnumeration
Enumeration timer
  #tim_circleIcon
  #tim_statusbar
EndEnumeration



Structure sGrid_ids  
  List *id.sMineId()
EndStructure
Structure sgrid_y
  y.sGrid_ids[3]
EndStructure
Structure sGrid
  x.sgrid_y[3]
EndStructure

Global NewList *CopyIds.sMineId()

Global grid.sgrid

Global fnt_small
LoadFont(fnt_small,"Segoe UI",9,#PB_Font_HighQuality)

Global win
Global men_win,men_Items,men_CostumRecipes
Global txt_vanilla,txt_datapack,txt_recipes,txt_advanced
Global bar_vanilla,bar_datapack,bar_recipes,bar_advanced
Global cbx_category
Global str_FindItem
Global btn_ClearFindItem
Global can_Grid
Global cls_items
Global grid_circle
Global opt_smelting,opt_shaped,opt_shapeless
Global txt_Group,str_Group
Global txt_result,can_result
Global txt_experience,str_experience
Global txt_cookingtime,str_cookingtime
Global spn_count,txt_count
Global chk_Trigger,can_Trigger
Global cls_CostumRecipes
Global str_namespace,txt_namespace
Global str_title,txt_title
Global sbr_win

Declare can_Grid_draw()
Declare can_result_draw()
Declare win_visible()
Declare can_Trigger_draw()

Procedure TimedMessage(text.s)
  StatusBarText(sbr_win,0,text)
  AddWindowTimer(win,#tim_statusbar,5000)
EndProcedure

Global TextH

Procedure.s getTextLimit(str.s,width,pos=0)
  Protected *char.character,*savechar
  Protected out.s
  str=Trim(Mid(str,pos+1))
  out=""
  *char=@str
  *savechar=0
  While *char\c<>0 And TextWidth(out)<width
    If *char\c=32 Or *char\c='_' Or *char\c='.' Or *char\c=':' Or *char\c='-'
      *savechar=*char
    EndIf
    *char+SizeOf(character)   
    out=Left(str,(*char-@str)/SizeOf(character))
    If *char\c=0
      *savechar=*char
    EndIf    
  Wend
  
  If *savechar
    ProcedureReturn Left(str,(*savechar-@str)/SizeOf(character))
  EndIf
  ProcedureReturn Left(str,(*char-@str)/SizeOf(character)-1)
EndProcedure
Procedure DrawGridBox(x,y,w,h)
  UnclipOutput()
  DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_Transparent)
  Box(x, y, w, h,#Black)  
EndProcedure
Procedure DrawGridPlusBox(x,y,w,h)
  UnclipOutput()
  DrawingMode(#PB_2DDrawing_Default)
  Box(x+w-texth-2,y+w-texth-2,texth+2,texth+2,#White)
  DrawingMode(#PB_2DDrawing_Outlined|#PB_2DDrawing_Transparent)
  Box(x+w-texth-2,y+w-texth-2,texth+2,texth+2,#Black)
  DrawText(x+w-texth+(texth-TextWidth("＋"))/2,y+w-texth,"＋",#Black)
EndProcedure


Procedure DrawIcon(xx,yy,w,h,*id.sMineId)
  Protected str.s,str2.s
  Protected *tag.sTags
  Protected icon
 
  ClipOutput(xx+2,yy+2,w-4,h-4)
 
  str=getTextLimit(*id\lang,w-4)
  str2=getTextLimit(*id\lang,w-4,Len(str))
            
  icon=*id\icon
  If icon=0 And *id\isTag
    *tag=*id
    If ListSize(*tag\idlink())
      SelectElement(*tag\idlink(), grid_circle % ListSize( *tag\idlink() ))
      icon=*tag\idlink()\icon
    EndIf
  EndIf
            
            
  If icon
    yy+ (h-(ImageHeight(icon)+5+TextH))/2
    DrawingMode(#PB_2DDrawing_AlphaBlend)
    DrawImage( ImageID(icon),
               xx+(#grid_width-ImageWidth(icon))/2,
               yy)
    yy+ImageWidth(icon)+5
  Else
    yy+ (h-TextH)/2
  EndIf
            
  DrawingMode(#PB_2DDrawing_Transparent)
            
  DrawText(xx+(w-TextWidth(str))/2 ,
           yy,
           str,#Black,#White)
  yy+TextHeight(str)          
  
  DrawText(xx+(w-TextWidth(str2))/2 ,
           yy,
           str2,#Black,#White)
  
EndProcedure
Procedure DrawTextLine(x,y,*Id.sMineId)
  Protected str.s
  Protected *tag.sTags
  Protected icon
  Protected w
  icon=*id\icon
  If icon=0 And *id\isTag
    *tag=*id
    If ListSize(*tag\idlink())
      SelectElement(*tag\idlink(), grid_circle % ListSize( *tag\idlink() ))
      icon=*tag\idlink()\icon
    EndIf
  EndIf
        
  If icon
    w=TextH * ImageWidth(icon)/ImageHeight(icon)
    DrawingMode(#PB_2DDrawing_AlphaBlend)
    DrawImage(ImageID(icon),x,y,w,TextH)
  EndIf
  
  DrawingMode(#PB_2DDrawing_Transparent)
  DrawText(x+TextH+2,y,*id\lang,#Black)
EndProcedure

Procedure _fillcostumRecipes(count)
  Protected *id.sMineId,icon
  ForEach CostumRecipe()
    Debug CostumRecipe()\name+" "+FindString(CostumRecipe()\name,":")
    If CountString(CostumRecipe()\name,":")=count
      *id=findMinecraftID(CostumRecipe()\recipe\result\item)
      If *id
        icon=*id\icon
      Else 
        icon=0
      EndIf
      
      canlist::AddItem(cls_CostumRecipes, CostumRecipe()\name, icon)
    EndIf
  Next
EndProcedure

Procedure FillCostumRecipe()
  
  SortStructuredList(CostumRecipe(),#PB_Sort_Ascending,OffsetOf(sMineRecipe\name),#PB_String)
  
  canlist::Clear(cls_CostumRecipes)
  
  canlist::AddItem(cls_CostumRecipes,"-- minecraft --",0,0,"", CanList::#ItemStyle_Disabled)
  _fillcostumRecipes(1)
  canlist::AddItem(cls_CostumRecipes,"-- own namespace --",0,0,"", CanList::#ItemStyle_Disabled)
  _fillcostumRecipes(0)
  
  canlist::FinishItemChange(cls_CostumRecipes)
EndProcedure

  
Procedure FillItems()
  Protected str.s
  
  str=GetGadgetText(str_FindItem)
  
  NewList items.sGadItem()
  
  If FindMapElement(Category(),GetGadgetText(cbx_category))
         
    ForEach Category()\id()
      If str="" Or FindString(Category()\id()\lang,str,0,#PB_String_NoCase)
        AddElement(items())
        items()\dat=category()\id()
        items()\text=Category()\id()\lang
        items()\icon=Category()\id()\icon
        items()\tooltip=category()\id()\id
        If Category()\id()\hasRecipe
          items()\text+"®"
        EndIf
        If Category()\id()\isIngredient
          items()\text+"ⁱ"
        EndIf
          
      EndIf
    Next
    
    SortStructuredList(items(),#PB_Sort_Ascending,OffsetOf(sGadItem\text),#PB_String)
    
    canlist::Clear(cls_items)
    ForEach items()
      canlist::AddItem(cls_items,items()\text,items()\icon,items()\dat,items()\tooltip)
      
    Next
    canlist::FinishItemChange(cls_items)
    
    
  EndIf
EndProcedure
Procedure FillCategory()
  NewList items.sGadItem()
  ForEach Category()
    AddElement(items())
    items()\text=MapKey(Category())    
  Next
  
  GadgetSortFill(cbx_category,items())
EndProcedure




Procedure ClearRecipe()
  Protected x,y
  SetGadgetState(opt_shaped,#True)
  SetGadgetState(opt_shapeless,#False)
  SetGadgetState(opt_smelting,#False)
  For x=0 To 2
    For y=0 To 2
      ClearList( grid\x[x]\y[y]\id() )
    Next
  Next
  
  SetGadgetText(str_Group,"")
  SetGadgetData(can_result,0)
  SetGadgetText(spn_count,"1")
  
  SetGadgetText(str_cookingtime,"200")
  SetGadgetText(str_experience,"0.1")
  
  SetGadgetData(can_Trigger,0)
  SetGadgetState(chk_Trigger,0)
  
  can_Grid_draw()
  can_result_draw()
  can_Trigger_draw()
  win_visible()
EndProcedure

Procedure checkRecipe()
  Protected x,y
  Protected ret,ok
   
  If GetGadgetState(opt_smelting)
    If ListSize(grid\x[0]\y[0]\id())>0
      ret=#True
    EndIf   
  Else
    For x=0 To 2
      For y=0 To 2
        If ListSize(grid\x[x]\y[y]\id())>0
          ret=#True
          Break 2
        EndIf
      Next      
    Next
    
    If Val(GetGadgetText(spn_count))<=0
      ret=#False
    EndIf    
  EndIf
  
  If GetGadgetData(can_result)=0
    ret=#False
  EndIf  
    
  If GetGadgetState(chk_Trigger) And GetGadgetData(can_Trigger)=#Null
    ret=#False    
  EndIf
  
  ProcedureReturn ret
EndProcedure

Procedure ExportRecipe(*recipe.sRecipe)
  Protected *id.sMineId
  Protected x,y
  Protected *idlist.sGrid_ids
  Protected key.s,ok
  
  ResetStructure(*recipe,sRecipe)
  
  If GetGadgetState(opt_shaped)
    *recipe\type=#recipe_crafting_shaped
  ElseIf GetGadgetState(opt_shapeless)
    *recipe\type=#recipe_crafting_shapeless
  Else
    *recipe\type=#recipe_Smelting
  EndIf
  
  *recipe\group=GetGadgetText(str_Group)
  *recipe\result\count=Val(GetGadgetText(spn_count))
  *recipe\cookingtime=Val(GetGadgetText(str_cookingtime))
  *recipe\experience=ValD(GetGadgetText(str_experience))
  
  *id=GetGadgetData(can_result)
  If *id
    *recipe\result\item=*id\id
  EndIf
  
  If GetGadgetState(chk_Trigger)
    *id=GetGadgetData(can_Trigger)
    If *id
      *recipe\trigger=*id\id
    EndIf
  EndIf
  
  
  Select *recipe\type
    Case #recipe_crafting_shaped
      For x=0 To 2
        For y=0 To 2
          *idlist=grid\x[x]\y[y]
          
          If ListSize(*idlist\id())
            SortStructuredList(*idlist\id(),#PB_Sort_Ascending,OffsetOf(sMineId\id),#PB_String)
            
            ForEach *recipe\key()
              ResetList(*idlist\id())
              ok=#True
              ForEach *recipe\key()\item()
                If Not( NextElement(*idlist\id()) And *idlist\id()\id = *recipe\key()\item() )
                  ok=#False
                  Break
                EndIf
              Next
              If NextElement(*idlist\id())
                ok=#False
              EndIf
              If ok
                key=*recipe\key()\key
                Break              
              EndIf
            Next
            
            If ok=#False
              AddElement(*recipe\key())
              key=Chr('A'+y*3+x)
              *recipe\key()\key=key
              ForEach *idlist\id()
                AddElement(*recipe\key()\item())
                *recipe\key()\item()=*idlist\id()\id
              Next
            EndIf
          Else
            key=" "
          EndIf
          
          *recipe\pattern[y]+key 
                
        Next
      Next
      While Left(*recipe\pattern[0],1)=" " And Left(*recipe\pattern[1],1)=" " And Left(*recipe\pattern[2],1)=" "
        *recipe\pattern[0]=Mid( *recipe\pattern[0] ,2)
        *recipe\pattern[1]=Mid( *recipe\pattern[1] ,2)
        *recipe\pattern[2]=Mid( *recipe\pattern[2] ,2)
      Wend
      While Right(*recipe\pattern[0],1)=" " And Right(*recipe\pattern[1],1)=" " And Right(*recipe\pattern[2],1)=" "
        *recipe\pattern[0]=Left( *recipe\pattern[0] , Len(*recipe\pattern[0])-1 )
        *recipe\pattern[1]=Left( *recipe\pattern[1] , Len(*recipe\pattern[1])-1 )
        *recipe\pattern[2]=Left( *recipe\pattern[2] , Len(*recipe\pattern[2])-1 )
      Wend
      If Trim(*recipe\pattern[0])=""
        *recipe\pattern[0]=*recipe\pattern[1]
        *recipe\pattern[1]=*recipe\pattern[2]
        *recipe\pattern[2]=""
        If Trim(*recipe\pattern[0])=""
          *recipe\pattern[0]=*recipe\pattern[1]
          *recipe\pattern[1]=""
        EndIf
      EndIf
      If Trim(*recipe\pattern[2])=""
        *recipe\pattern[2]=""
        If Trim(*recipe\pattern[1])=""
          *recipe\pattern[1]=""
        EndIf
      EndIf
      Debug "bot"
      For x=0 To 2
        Debug "*"+*recipe\pattern[x]+"*"
      Next
      
      
    Case #recipe_crafting_shapeless
      For x=0 To 2
        For y=0 To 2
          *idlist=grid\x[x]\y[y]
          If ListSize(*idlist\id())
            AddElement(*recipe\ingredients())
            ForEach *idlist\id()
              AddElement(*recipe\ingredients()\item())
              *recipe\ingredients()\item()=*idlist\id()\id
            Next
          EndIf
        Next
      Next
      
    Case #recipe_Smelting
      AddElement(*recipe\ingredients())
      ForEach grid\x[0]\y[0]\id()
        AddElement(*recipe\ingredients()\item())
        *recipe\ingredients()\item()=grid\x[0]\y[0]\id()\id
      Next
  EndSelect
EndProcedure

        
Procedure ImportRecipe(*recipe.sRecipe)
  Protected x,y
  Protected key.s,*id.sMineId
  
  ClearRecipe()
  
  SetGadgetText(str_Group,*recipe\group)
  
  SetGadgetData(can_result, findMinecraftID(*recipe\result\item) )
  SetGadgetData(can_Trigger, findMinecraftID(*recipe\trigger))
  If *recipe\trigger<>""
    SetGadgetState(chk_Trigger,#PB_Checkbox_Checked)
  EndIf
  
  SetGadgetText(spn_count,Str( *recipe\result\count ))
      
  SetGadgetText(str_cookingtime,Str(*recipe\cookingtime))
  SetGadgetText(str_experience,StrD(*recipe\experience))
  
  Select *recipe\type
    Case #recipe_crafting_shaped
      SetGadgetState(opt_shaped,#True)
      
      For x=0 To 2
        For y=0 To 2
          
          key=Mid(*recipe\pattern[y],x+1,1)
          
          ForEach *recipe\key()
            If *recipe\key()\key=key
              ForEach *recipe\key()\item()
                *id=findMinecraftID(*recipe\key()\item())
                If *id
                  AddElement( grid\x[x]\y[y]\id() )
                  grid\x[x]\y[y]\id()=*id
                EndIf
              Next
              Break
            EndIf
          Next
          
        Next
      Next
      
    Case #recipe_crafting_shapeless
      SetGadgetState(opt_shapeless,#True)
      SetGadgetState(opt_shaped,#False)
      x=0:y=0
      ForEach *recipe\ingredients()
        ForEach *recipe\ingredients()\item()
          *id=findMinecraftID(*recipe\ingredients()\item())
          If *id
            AddElement( grid\x[x]\y[y]\id() )
            grid\x[x]\y[y]\id()=*id
          EndIf
        Next
        x+1
        If x=3
          x=0
          y+1
          If y=3
            Break
          EndIf
        EndIf
      Next
      
    Case #recipe_Smelting
      SetGadgetState(opt_smelting,#True)
      SetGadgetState(opt_shaped,#False)
      ForEach *recipe\ingredients()
        ForEach *recipe\ingredients()\item()
          *id=findMinecraftID(*recipe\ingredients()\item())
          If *id
            AddElement( grid\x[0]\y[0]\id() )
            grid\x[0]\y[0]\id()=*id
          EndIf
        Next
      Next
      
  EndSelect
  
  can_Grid_draw()
  can_result_draw()
  can_Trigger_draw()
  win_visible()
      
EndProcedure


Procedure cbx_category_change()
  FillItems()
EndProcedure
Procedure str_FindItem_change()
  FillItems()
EndProcedure
Procedure btn_ClearFindItem_all()
  SetGadgetText(str_FindItem,"")
  SetActiveGadget(str_FindItem)
  str_FindItem_change()
EndProcedure

Procedure can_Result_draw()
  Protected *id.sMineId
  Protected str.s,str2.s
  Protected yy=2
  
  If StartDrawing(CanvasOutput(can_result))
    DrawingFont(FontID(fnt_small))
    Box(0,0,#grid_height,#grid_width,#White)
    
    DrawGridBox(0,0,#grid_height,#grid_width)
    ClipOutput(2,2,#grid_width,#grid_height)
    
    *id=GetGadgetData(can_result)
    If *id
      DrawIcon(2,2,#grid_width-4,#grid_height-4,*id)
    EndIf
    
    StopDrawing()
  EndIf
EndProcedure

Procedure can_result_mousemove()
  Protected newstate
  Static oldstate
  
  If ListSize(*CopyIds())
    newstate=#PB_Cursor_Cross
  Else
    newstate=#PB_Cursor_Default
  EndIf
  If oldstate<>newstate
    oldstate=newstate
    SetGadgetAttribute(can_result,#PB_Canvas_Cursor,newstate)
  EndIf  
  
EndProcedure

Procedure can_result_LeftClick()
  Protected item,*id.sMineId
  
  If ListSize(*CopyIds())>0 And FirstElement(*CopyIds())
    *id=*CopyIds()
    ClearList(*CopyIds())
  Else
    item=CanList::GetState(cls_items)
    If item<0
      ProcedureReturn #False
    EndIf
    *id=CanList::GetItemData(cls_items,item)
  EndIf  
  
  If *id=0 Or *id\isTag=#True
    ProcedureReturn #False
  EndIf
  
  SetGadgetData(can_result,*id)
  can_Result_draw()
    
EndProcedure

Procedure can_result_RightClick()
  Protected *id
  If ListSize(*CopyIds())>0
    ClearList(*CopyIds())
    ProcedureReturn #False
  EndIf
  
  *id=GetGadgetData(can_result)
  If *id=0
    ProcedureReturn #False
  EndIf
  AddElement(*CopyIds())
  *CopyIds()=*id
EndProcedure

Procedure can_Trigger_mousemove()
  Protected newstate
  Static oldstate
  
  If ListSize(*CopyIds())
    newstate=#PB_Cursor_Cross
  Else
    newstate=#PB_Cursor_Default
  EndIf
  If oldstate<>newstate
    oldstate=newstate
    SetGadgetAttribute(can_Trigger,#PB_Canvas_Cursor,newstate)
  EndIf  
  
EndProcedure


Procedure can_Trigger_LeftClick()
  Protected item,*id.sMineId
  
  If ListSize(*CopyIds())>0 And FirstElement(*CopyIds())
    *id=*CopyIds()
    ClearList(*CopyIds())
  Else
    item=CanList::GetState(cls_items)
    If item<0
      ProcedureReturn #False
    EndIf
    *id=CanList::GetItemData(cls_items,item)
  EndIf
   
  If *id=0
    ProcedureReturn #False
  EndIf
  
  SetGadgetData(can_Trigger,*id)
  can_Trigger_draw()
    
EndProcedure

Procedure can_Trigger_RightClick()
  Protected *id
  If ListSize(*CopyIds())>0
    ClearList(*CopyIds())
    ProcedureReturn #False
  EndIf
  
  *id=GetGadgetData(can_Trigger)
  If *id=0
    ProcedureReturn #False
  EndIf
  AddElement(*CopyIds())
  *CopyIds()=*id
EndProcedure

Procedure can_Trigger_draw()
  Protected *id.sMineId
  Protected str.s,str2.s
  Protected yy=2
  
  If StartDrawing(CanvasOutput(can_Trigger))
    DrawingFont(FontID(fnt_small))
    Box(0,0,#grid_height,#grid_width,#White)
    
    DrawGridBox(0,0, #grid_width, #grid_height)
    ClipOutput(2,2,#grid_width,#grid_height)
    
    *id=GetGadgetData(can_Trigger)
    If *id
      DrawIcon(2,2,#grid_width-4,#grid_height-4,*id)
    EndIf
    
    StopDrawing()
  EndIf
EndProcedure




Procedure can_Grid_draw()
  Protected x,y,*idlist.sGrid_ids,str.s,str2.s
  Protected xx,yy,count
  Protected offy,w,h
  Protected icon
  Protected *tag.sTags

  If StartDrawing(CanvasOutput(can_Grid))
    Box(0,0,#grid_height*3,#grid_width*3,#White)
    
    DrawingFont(FontID(fnt_small))
    
    If TextH=0
      TextH=TextHeight("＋")
    EndIf
    
    
    If GetGadgetState(opt_smelting)
      ;smelting-liste
      
      DrawGridBox(xx,yy,#grid_width*3,#grid_height*3)
      ClipOutput(xx+2,yy+2,#grid_width*3-4,#grid_height*3-4)
      
      *idlist=grid\x[0]\y[0]
      
      count=ListSize(*idlist\id())
      If count>9
        yy=2
        xx=2
        ForEach *idlist\id()            
          DrawTextLine(xx,yy, *idlist\id())
          yy+texth
        Next
      Else
        x=0:y=0
        ForEach *idlist\id()
          xx=x * #grid_width 
          yy=y * #grid_height
          
          ClipOutput(xx+2,yy+2,#grid_width-4,#grid_height-4)
          DrawIcon(xx+2,yy+2,#grid_width-4,#grid_height-4,*idlist\id() )
          
          x+1
          If x>=3
            x=0
            y+1
          EndIf
        Next
      EndIf
      
    Else
      
      For x=0 To 2
        For y=0 To 2
          *idlist=grid\x[x]\y[y]
          xx=x * #grid_width 
          yy=y * #grid_height
                    
          DrawGridBox(xx,yy,#grid_width,#grid_height)
          ClipOutput(xx+2,yy+2,#grid_width-4,#grid_height-4)
          
          If ListSize(*idlist\id())=1 And FirstElement(*idlist\id())
            
            DrawIcon(xx+2,yy+2,#grid_width-4,#grid_height-4,*idlist\id() )
            
          ElseIf ListSize(*idlist\id())>1       
            count=ListSize(*idlist\id())
            
            offy=((#grid_height-4) - count * TextH)/2
            If offy<0
              offy= -( grid_circle % (count-#grid_height/TextH+2)) * TextH 
            EndIf
            
            yy+2+offy
            xx+2
            ForEach *idlist\id()
              DrawTextLine(xx+2,yy+2,*idlist\id())
              yy+textH            
            Next
            
          EndIf
          
          DrawGridPlusBox(x*#grid_width,y*#grid_height,#grid_width,#grid_height)
          
        Next
      Next
      
    EndIf
    
    StopDrawing()
  EndIf
  
  
EndProcedure
Procedure can_grid_MouseMove()
  Protected xx,yy,x,y,inplus
  Static oldstate,newstate
  
  If GetGadgetState(opt_smelting)=#False
    xx=GetGadgetAttribute(can_Grid, #PB_Canvas_MouseX)
    yy=GetGadgetAttribute(can_Grid, #PB_Canvas_MouseY)
    x=xx/#grid_width
    y=yy/#grid_height
    If  xx>(x+1) * #grid_width-texth-2 And yy>(y+1) * #grid_width-texth-2
      inPlus=#True
    EndIf
      
  EndIf
  
  If ListSize(*CopyIds())>0
    newstate=#PB_Cursor_Cross
  ElseIf inplus 
    newstate=#PB_Cursor_Hand
  Else
    newstate=#PB_Cursor_Default
  EndIf
  
  If oldstate<>newstate
    oldstate=newstate
    SetGadgetAttribute(can_Grid,#PB_Canvas_Cursor,newstate)
  EndIf
  
EndProcedure

Procedure can_Grid_LeftClick()
  Protected x,y,*idlist.sGrid_ids
  Protected item,*id.sMineId
  Protected inPlus,xx,yy
  Protected ok=#True
  
  If GetGadgetState(opt_smelting)
    x=0
    y=0
    inplus=#True
  Else    
    xx=GetGadgetAttribute(can_Grid, #PB_Canvas_MouseX)
    yy=GetGadgetAttribute(can_Grid, #PB_Canvas_MouseY)
    x=xx/#grid_width
    y=yy/#grid_height
    If  xx>(x+1) * #grid_width-texth-2 And yy>(y+1) * #grid_width-texth-2
      inPlus=#True
    EndIf
      
  EndIf
  
  If x<0 Or x>2 Or y<0 Or y>2
    ProcedureReturn #False
  EndIf
  
  *idlist=grid\x[x]\y[y]
  
  If ListSize(*CopyIds())>0
    ClearList(*idlist\id())
    ForEach *CopyIds()
      AddElement(*idlist\id())
      *idlist\id()=*CopyIds()
    Next
    
    ClearList(*CopyIds())
    can_Grid_draw()
    ProcedureReturn #True
  EndIf
  
  
  
  item=CanList::GetState(cls_items)
  If item<0
    ProcedureReturn #False
  EndIf
  
  *id=CanList::GetItemData(cls_items,item)
  If *id=0
    ProcedureReturn #False
  EndIf
  
  
  
  
  If inplus=#False   
    ;Replace!
    If ListSize(*idlist\id())>1 Or FirstElement(*idlist\id())=#False Or *idlist\id()<>*id
      ClearList(*idlist\id())
      AddElement(*idlist\id())
      *idlist\id()=*id
    Else
      ClearList(*idlist\id())
    EndIf        
  Else        
    ;Add!
    ForEach *idlist\id()
      If *idlist\id() = *id
        DeleteElement(*idlist\id())
        ok=#False
        Break
      EndIf
    Next
    If ok
      AddElement(*idlist\id())
      *idlist\id()=*id
    EndIf
  EndIf
    
  can_Grid_draw()

EndProcedure
Procedure can_Grid_RightClick()
  Protected x,y,*idlist.sGrid_ids
  
  If ListSize(*CopyIds())>0
    ClearList(*CopyIds())
    ProcedureReturn #False
  EndIf
  
  If GetGadgetState(opt_smelting)
    ProcedureReturn #False
  EndIf
  
  x=GetGadgetAttribute(can_Grid, #PB_Canvas_MouseX)/#grid_width
  y=GetGadgetAttribute(can_Grid, #PB_Canvas_MouseY)/#grid_height
  
  If x>=0 And x<=2 And y>=0 And y<=2
    *idlist=grid\x[x]\y[y]
    ForEach *idlist\id()
      AddElement(*CopyIds())
      *CopyIds()=*idlist\Id()
    Next
  EndIf

EndProcedure

Procedure SetLang(nb)
  Protected i,count,x,y,gad,*id.sMineId
  Debug "set lang:"+nb
  SelectElement(LangId(),nb)
  Debug LangId()\id 
  If pack::open("minecraft_vanilla.zip")
    Debug "openpack"
    LoadLanguage(LangId()\id)
    Debug "loaded"
    pack::Close()
  EndIf
  count=ListSize(LangId())
  For i=0 To count-1
    SetMenuItemState(men_win,#men_langstart+i,Bool(i=nb))
  Next
  
  FillItems()
  can_Grid_draw()
  can_result_draw()
  can_Trigger_draw()
EndProcedure

Procedure opt_shaped_all()
  can_Grid_draw()
  win_visible()
EndProcedure
Procedure opt_shapeless_all()
  can_Grid_draw()
  win_visible()
EndProcedure
Procedure opt_smelting_all()
  can_Grid_draw()
  win_visible()
EndProcedure


Procedure win_visible()
  Global smelting=GetGadgetState(opt_smelting)
  
  HideGadget(txt_count,smelting)
  HideGadget(spn_count,smelting)
  HideGadget(txt_cookingtime, smelting!1)
  HideGadget(txt_experience, smelting!1)
  HideGadget(str_cookingtime, smelting!1)
  HideGadget(str_experience, smelting!1)
EndProcedure
  
Procedure win_sizewindow()
  Protected winw=WindowWidth(win)
  Protected winh=WindowHeight(win)-MenuHeight()-StatusBarHeight(sbr_win)
  Protected y,x,xx,yy,maxY
  If txt_vanilla=0
    ProcedureReturn 0
  EndIf
  
  y=5:x=5
  
  y+GadNormal(txt_datapack,x,y,200)
  ResizeGadget(bar_datapack,x,y,200,2):y+4
  ResizeGadget(cls_CostumRecipes,x,y,200,winh-y-5)
    
  y=5:x+205
  
  y+GadNormal(txt_vanilla,x,y,200)
  ResizeGadget(bar_vanilla,x,y,200,2):y+4
  
  y+GadNormal(cbx_category,x,y,200)
  
  GadRight(btn_ClearFindItem,x,y,200)
  y+GadNormal(str_FindItem,x,y,GadgetX(btn_ClearFindItem)-x,GadgetHeight(btn_ClearFindItem))
  
  ResizeGadget(cls_items,x,y,200,winh-y-5)
  
  x+205
      
  y=5
  y+GadNormal(txt_recipes,x,y,#grid_width*3)
  ResizeGadget(bar_recipes,x,y,#grid_width*3,2):y+4
  
  GadNormal(opt_shaped    ,x                ,y,#grid_width)
  GadNormal(opt_shapeless ,x + #grid_width  ,y,#grid_width)
  y+GadNormal(opt_smelting,x + #grid_width*2,y,#grid_width)
  y+5
  
  yy=GadNormal(str_Group,x + #grid_width,y,#grid_width*2)
  y+GadMiddle(txt_Group,x,y,#grid_width,yy)
  y+5
  
  ResizeGadget(can_Grid,x,y,#grid_width*3,#grid_height*3)
  
  y+#grid_height*3
  y+5
  
  GadNormal(txt_result,x,y,#grid_width)
  ResizeGadget(can_result,x+#grid_width,y,#grid_width,#grid_height)
  y+#grid_width
  gadup(txt_count,x+#grid_width*2,y,#PB_Any)
  gadup(spn_count,x+#grid_width*2+GadgetWidth(txt_count),y,#PB_Any)
  
  y+5
  yy=GadNormal(str_experience,x+#grid_width,y,#grid_width)
  y+ GadNormal(txt_experience,x,y,#grid_width,yy)
  y+5
  yy=GadNormal(str_cookingtime,x+#grid_width,y,#grid_width)
  y+ GadNormal(txt_cookingtime,x,y,#grid_width,yy)
  
  y+5
  maxy=y
  
  x+#grid_width*3+5
  y=5
  
  y+GadNormal(txt_advanced,x,y,#grid_width*2)
  ResizeGadget(bar_advanced,x,y,#grid_width*2,2):y+4
    
  y+GadNormal(txt_title,x,y,#grid_width*2)
  y+GadNormal(str_title,x,y,#grid_width*2)
  
  y+5
  
  y+GadNormal(txt_namespace,x,y,#grid_width*2)
  y+GadNormal(str_namespace,x,y,#grid_width*2)
  
  y+5
  
  GadNormal(chk_Trigger,x,y,#grid_width)
  ResizeGadget(can_Trigger,x+#grid_width,y,#grid_width,#grid_height)
  y+#grid_height
  y+ 5
  
  
  
  
  
    
  x+#grid_width*2+5
  
  y=5
  
  maxy+MenuHeight()+StatusBarHeight(sbr_win)
  
  If Winw<x Or Winh<maxy
    Debug "winSize:"+x+" "+maxy
    ResizeWindow(win,#PB_Ignore,#PB_Ignore,x,maxy)
    WindowBounds(win,x,maxy,x,#PB_Default)
  EndIf
  
  win_visible()
  
EndProcedure

Procedure findMineRecipe(str.s)
  Protected ret=#False
  ForEach MineRecipe()
    If MineRecipe()\name=str
      ret=#True
      Break
    EndIf
  Next
  ProcedureReturn ret
EndProcedure


Procedure FindRecipe(str.s)
  Protected ret=#False
  ForEach CostumRecipe()
    If CostumRecipe()\name=str
      ret=#True
      Break
    EndIf
  Next
  ProcedureReturn ret
EndProcedure


Procedure win_menu()
  Protected str.s,ok,i,file.s,namespace.s,savenamespace.s
  Protected recipe.sRecipe
  Protected *id.sMineId
  Protected pack
  Protected *buf
  
  Select EventMenu()
    Case #men_importVanilla
      ClearList(CostumRecipe())
      ForEach MineRecipe()
        AddElement(CostumRecipe())
        CostumRecipe()\name="Minecraft:"+MineRecipe()\name
        CopyStructure( MineRecipe()\recipe,CostumRecipe()\recipe,sRecipe)
      Next
      FillCostumRecipe()
      TimedMessage("All minecraft vanilla recipes imported.")
      
    Case #men_loadDataPack
      ClearList(CostumRecipe())
      
      file=""
      file=OpenFileRequester(#title+" - Load DataPack",file,"zip|*.zip|all|*.*",0)
      If file And pack::Open(file)
        If json::Pack("pack.mcmeta")
          If json::OpenSub("pack")
            SetGadgetText(str_title, json::GetString("description") )
            json::CloseSub()
          EndIf
          json::Close()
        EndIf
        
        If pack::Examine("data/")
          While pack::Examine()
            file=pack::GetFileName()
            namespace=StringField(file,2,"/")
            Debug "file:"+file+" "+namespace
            If namespace="minecraft"
              Debug "  is minecraft"
              If isLeft(@file,@"data/minecraft/recipes/")
                Debug "  is recipe"
                AddElement(CostumRecipe())
                CostumRecipe()\name="minecraft:"+GetFilePart(file)
                If json::Pack()
                  Debug "  loaded recipe"
                  GetJsonRecipe(CostumRecipe()\recipe)
                  Debug "    "+CostumRecipe()\name+" "+CostumRecipe()\recipe\result\item
                  json::close()
                EndIf
              EndIf
            Else
              savenamespace=namespace
              str="data/"+namespace+"/recipes/"
              Debug "  <>"+str
              If IsLeft(@file,@str)
                Debug "  is Recipe"
                AddElement(CostumRecipe())
                CostumRecipe()\name=GetFilePart(file)
                If json::Pack()
                  GetJsonRecipe(CostumRecipe()\recipe)
                  json::close()
                EndIf
              Else
                str="data/"+namespace+"/advancements/recipes/"
                Debug "  <>"+str
                If IsLeft(@file,@str)
                  Debug "  isadvancements"
                  str=GetFilePart(file)
                  Debug "  file:"+str
                  If FindRecipe(str)
                    Debug "  recipe found"
                    If json::Pack()
                      Debug "  openpack"
                      If json::OpenSub("criteria")
                        Debug "  criteria"
                        If json::opensub("has_item")
                        
                        If JSOn::OpenSub("conditions")
                          Debug "  conditions"
                          If json::OpenArray("items")
                            Debug "  items"
                            While json::NextArrayEntry()
                              CostumRecipe()\recipe\trigger=json::GetString("item")
                            Wend
                            
                            json::CloseArray()
                          EndIf
                          
                          json::closesub()
                        EndIf
                        
                        json::CloseSub()
                        EndIf
                        
                        
                        json::CloseSub()
                      EndIf                        
                      json::close()
                    EndIf
                  EndIf
                EndIf
                
              EndIf
            EndIf
          
                
            
          Wend
        EndIf
        If savenamespace<>""
          SetGadgetText(str_namespace,savenamespace)
        EndIf
        pack::Close()
        
        FillCostumRecipe()
        TimedMessage("Datapack loaded.")
      EndIf
      
    Case #men_saveDataPack
      namespace=GetGadgetText(str_namespace)
      file=namespace+".zip"
      file=SaveFileRequester(#title +" - Save DataPack",file,"zip|*.zip|all|*.*",0)
      If file
        If CreatePack(pack,file)
          If json::New()
            If json::CreateSub("pack")
              json::SetString("description",GetGadgetText(str_title))
              json::SetInteger("pack_format",1)
              json::CloseSub()
            EndIf
            
            *buf=json::Export()
            If *buf
              AddPackMemory(pack,*buf,MemorySize(*buf),"pack.mcmeta")
              FreeMemory(*buf)
            EndIf
            
            AddPackMemory(pack, ?rootjson, ?endrootjson-?rootjson , "data/"+namespace+"/advancements/recipes/root.json")
            
            json::Close()
          EndIf
            
          ForEach CostumRecipe()
            If CreateJsonRecipe(CostumRecipe()\recipe)
              *buf=json::Export()
              If *buf
                
                If FindString(CostumRecipe()\name,":")>0
                  str="data/"+StringField(CostumRecipe()\name,1,":")+"/recipes/"+StringField(CostumRecipe()\name,2,":")
                Else
                  str="data/"+namespace+"/recipes/"+CostumRecipe()\name
                EndIf
                
                AddPackMemory(pack,*buf,MemorySize(*buf),str)
                FreeMemory(*buf)
              EndIf                
              
              json::Close()
            EndIf
            
            If CostumRecipe()\recipe\trigger<>"" And FindString(CostumRecipe()\name,":")<=0
              str=PeekS(?advancements,?EndAdvancements-?advancements,#PB_UTF8)
              str=ReplaceString(str,"%%parent%%",namespace+":recipes/root")
              str=ReplaceString(str,"%%recipe%%",namespace+":"+Left(CostumRecipe()\name,Len(CostumRecipe()\name )-5))
              If Left(CostumRecipe()\recipe\trigger,1)="#"
                str=ReplaceString(str,"%%itemtype%%","tag")
                str=ReplaceString(str,"%%item%%",Mid(CostumRecipe()\recipe\trigger,2))
              Else                
                str=ReplaceString(str,"%%itemtype%%","item")
                str=ReplaceString(str,"%%item%%",CostumRecipe()\recipe\trigger)
              EndIf
              *buf=UTF8(str)
              AddPackMemory(pack,*buf,MemorySize(*buf)-1,"data/"+namespace+"/advancements/recipes/"+CostumRecipe()\name)
              FreeMemory(*buf)
            EndIf
            
            
          Next    
            
          ClosePack(pacK)
          TimedMessage("DataPack saved.")
         
        EndIf
      EndIf      
      
    Case #men_openRecipe
      If FindRecipe( CanList::GetText(cls_CostumRecipes) )
        ImportRecipe(CostumRecipe()\recipe)
        TimedMessage(CostumRecipe()\name+" opend.")
      EndIf
                
    Case #men_NewRecipe
      If checkRecipe() 
        *id=GetGadgetData(can_result)
        str=StringField(*id\id,2,":")
        file=str+".json"
        i=1
        While FindRecipe(file) Or findMineRecipe(file)
          file=str+"_"+i+".json"
          i+1
        Wend        
        
        Repeat
          file=InputRequester("Enter Recipe-File-Name","Only low case, nummerbs and underline is allowed!",file)
        Until file="" Or (allowedchars(Left(file,Len(file)-5)) And FindRecipe(file)=#False And Right(file,5)=".json" And findMineRecipe(file)=#False)
          
        If file<>""
          AddElement(CostumRecipe())
          CostumRecipe()\name=file
          ExportRecipe(CostumRecipe()\recipe)
          FillCostumRecipe()
          TimedMessage("New recipe created.")
        EndIf
      Else
        MessageRequester(#title,"Recipe is not valid")
      EndIf
      
    Case #men_OverwriteRecipe
      If checkRecipe()
        If FindRecipe( CanList::GetText(cls_CostumRecipes) )
          ExportRecipe(CostumRecipe()\recipe)
          FillCostumRecipe()
          TimedMessage("Recipe overwritten.")
        EndIf
      Else
        MessageRequester(#title,"Recipe is not valid")
      EndIf
      
    Case #men_RemoveRecipe
      If FindRecipe( CanList::GetText(cls_CostumRecipes) )
        DeleteElement(CostumRecipe())
        FillCostumRecipe()
        TimedMessage("Recipe removed.")
      EndIf
      
    Case #men_OverwriteMineRecipe To #men_lastOverwriteMineRecipe
      str=GetMenuItemText(men_Items,EventMenu())
      file="minecraft:"+str
      If FindRecipe(file)
        ExportRecipe(CostumRecipe()\recipe)
        FillCostumRecipe()
        TimedMessage("Minecraft recipe overwritten.")
      Else
        AddElement(CostumRecipe())
        CostumRecipe()\name=file
        ExportRecipe(CostumRecipe()\recipe)
        FillCostumRecipe()
        TimedMessage("Minecraft recipe overwritten.")
      EndIf
      
      
    Case #men_recipe To #men_lastrecipe
      str=GetMenuItemText(men_Items,EventMenu())
      ForEach MineRecipe()
        If MineRecipe()\name=str
          ImportRecipe( MineRecipe()\recipe )
        EndIf
      Next
      TimedMessage("Minecraft recipe imported.")
      
    Case #men_recipeExport
      If checkRecipe()=#False
        MessageRequester(#title,"Error in the recipe")
      Else
        *id=GetGadgetData(can_result)
        str=StringField(*id\id,2,":")
        file=str+".json"
        
        file=SaveFileRequester(#title+" - Export recipe",file,"java|*.json|all|*.*",0)
        If file
          ExportRecipe(recipe)
          CreateJsonRecipe(recipe)
          json::Save(file)
          json::Close()
          TimedMessage("Recipe exported.")
        EndIf
      EndIf
      
    Case #men_recipeImport
      file=".json"
      file=OpenFileRequester(#title+" - Import recipe",file,"java|*.json|all|*.*",0)
      If file
        If json::Open(file)
          GetJsonRecipe(recipe)
          ImportRecipe(recipe)
          json::Close()
          TimedMessage("Recipe imported.")
        EndIf
      EndIf
      
    Default
      If EventMenu()>=#men_langstart
        SetLang(EventMenu()-#men_langstart)
      EndIf
  EndSelect
  
  DataSection
    rootjson:
    IncludeBinary "root.json"
    EndRootjson:
    advancements:
    IncludeBinary "advancements_1.json"
    EndAdvancements:
  EndDataSection
  
  
EndProcedure

Procedure cls_CostumRecipes_rightclick()
  Protected item,file.s
  Protected ok=checkRecipe()
  CreatePopupMenu(men_CostumRecipes)
  
  item=CanList::GetState(cls_CostumRecipes)
  If item>=0
    MenuItem(#men_openRecipe,"Open")
    MenuBar()
  EndIf    
  If ok
    MenuItem(#men_NewRecipe,"New")
  EndIf
  If item>=0    
    If ok
      OpenSubMenu("Overwrite")
      MenuItem(#men_OverwriteRecipe, "confirm")
      CloseSubMenu()
    EndIf
    OpenSubMenu("Delete")
    MenuItem(#men_RemoveRecipe,"confirm")
    CloseSubMenu()
  EndIf
  DisplayPopupMenu(men_CostumRecipes,WindowID(win))
EndProcedure

Procedure cls_CostumRecipes_LeftDoubleClick()
  Protected str.s
  str=CanList::GetText(cls_CostumRecipes)
  If str<>"" And FindRecipe(str)
    ImportRecipe(CostumRecipe()\recipe)
  EndIf
EndProcedure
 
  
Procedure cls_items_RightClick()
  Protected item,*id.sMineId,*tag.sTags
  Protected str.s,i,x,y
  
  NewList ingred.s()
  
  item=CanList::GetState(cls_items)
  If item<0
    ProcedureReturn #False
  EndIf
  
  *id=CanList::GetItemData(cls_items,item)
  If *id=0
    ProcedureReturn #False
  EndIf
  
  If *id\isIngredient
    ForEach MineRecipe()
      ForEach MineRecipe()\recipe\ingredients()
        ForEach  MineRecipe()\recipe\ingredients()\item()
          str=MineRecipe()\recipe\ingredients()\item() 
          If Left(str,1)="#"
            *tag=findMinecraftID(str)
            If *tag And *tag\isTag=#True
              ForEach *tag\idlink()
                If *tag\idlink()=*id
                  AddElement(ingred())
                  ingred()=MineRecipe()\name
                  Break 3
                EndIf
              Next
            EndIf          
          ElseIf str= *id\id
            AddElement(ingred())
            ingred()=MineRecipe()\name
            Break 2
          EndIf
        Next
      Next
      ForEach MineRecipe()\recipe\key()
        ForEach MineRecipe()\recipe\key()\item()
          str= MineRecipe()\recipe\key()\item() 
          If Left(str,1)="#"
            *tag=findMinecraftID(str)
            If *tag And *tag\isTag=#True
              ForEach *tag\idlink()
                If *tag\idlink()=*id
                  AddElement(ingred())
                  ingred()=MineRecipe()\name
                  Break 3
                EndIf
              Next
            EndIf          
          ElseIf str = *id\id
            AddElement(ingred())
            ingred()=MineRecipe()\name
            Break 2
          EndIf
        Next
      Next
    Next
  EndIf
  
  If men_Items
    FreeMenu(men_items)
  EndIf    
  CreatePopupMenu(men_items)
  
  If *id\hasRecipe Or *id\isIngredient
    If checkRecipe()
      i=#men_OverwriteMineRecipe
      OpenSubMenu("Overwrite")
      
      If *id\hasRecipe
        OpenSubMenu("Result")
        ForEach MineRecipe()
          If MineRecipe()\recipe\result\item=*id\id
            MenuItem(i, MineRecipe()\name)
            i+1
            If i>#men_lastOverwriteMineRecipe
              Break
            EndIf          
          EndIf
        Next
        CloseSubMenu()
      EndIf
      If *id\isIngredient
        OpenSubMenu("Ingredient")
        ForEach ingred()
          MenuItem(i,ingred())  
          i+1
          If i>#men_lastOverwriteMineRecipe
            Break
          EndIf          
        Next
        CloseSubMenu()
      EndIf
      CloseSubMenu()
    EndIf
  EndIf
  
  i=#men_recipe
  If *id\hasRecipe
    OpenSubMenu("Result")
    
    ForEach MineRecipe()
      If MineRecipe()\recipe\result\item=*id\id
        MenuItem(i, MineRecipe()\name)
        i+1
        If i>#men_lastrecipe
          Break
        EndIf          
      EndIf
    Next
    CloseSubMenu()    
  EndIf
  
  If *id\isIngredient
    OpenSubMenu("Ingredient")
    ForEach ingred()
      MenuItem(i,ingred())  
      i+1
      If i>#men_lastrecipe
        Break
      EndIf          
    Next
    CloseSubMenu()
  EndIf
  
  
  DisplayPopupMenu(men_Items,WindowID(win))
  
  
EndProcedure

Procedure spn_count_up()
  Protected a
  a=GetGadgetState(spn_count)
  If a>1
    SetGadgetText(spn_count,Str(a-1))
  EndIf
EndProcedure
Procedure spn_count_down()
  Protected a
  a=GetGadgetState(spn_count)
  If a<999
    SetGadgetText(spn_count,Str(a+1))
  EndIf
EndProcedure
Procedure str_namespace_change()
  Protected str.s,str2.s,i
  str=GetGadgetText(str_namespace)
  If allowedchars(str)=#False
    For i=1 To Len(str)
      If allowedchars(Mid(str,i,1))
        str2+Mid(str,i,1)
      EndIf
    Next
    SetGadgetText(str_namespace,str2)
  EndIf
EndProcedure


;-
;- main
;-

Define x,y,i ,str.s
  
OpenWindow(win,0,0,800,600,#title+" - "+#version,#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_Invisible)
If win=0
  Debug "NO WINDOW"
  End
EndIf

CreateStatusBar(sbr_win,WindowID(win))
AddStatusBarField(#PB_Ignore )

CreateMenu(men_win,WindowID(win))
If men_win=0
  Debug "NO MENU"
  End
EndIf

MenuTitle("File")
MenuItem(#men_loadDataPack,"Load DataPack")
MenuItem(#men_saveDataPack,"Save DataPack")
MenuBar()
MenuItem(#men_recipeImport,"Import Recipe")
MenuItem(#men_recipeExport,"Export Recipe")
MenuBar()

OpenSubMenu("Import all vanilla recipes")
MenuItem(#men_importVanilla,"confirm")
CloseSubMenu()

MenuTitle("Item Language")
i=0
str=""
Define str2.s
ForEach LangId()
  str=LangId()\mainid
  i=0
  str2=LangId()\name  
  PushListPosition(LangId())
  Repeat
    If LangId()\mainid=str 
      If langid()\id=str+"_"+str
        str2=LangId()\name
      EndIf
      i+1
    EndIf
  Until NextElement(LangId())=#False
  PopListPosition(langid())
  
  If i=1 
    MenuItem(#men_langstart+ListIndex(langid()),LangId()\name+Chr(9)+LangId()\region)
  Else
    OpenSubMenu(str2)
    Repeat
      MenuItem(#men_langstart+ListIndex(langid()),LangId()\name+Chr(9)+LangId()\region)
      If NextElement(LangId()) = #False
        Break
      ElseIf LangId()\mainid<>str
        PreviousElement(langid())
        Break
      EndIf
    ForEver
    CloseSubMenu()
        
  EndIf
  
Next

TextGadget(txt_advanced,0,0,0,0,"Advanced")
TextGadget(txt_vanilla,0,0,0,0,"Minecraft Vanilla")
TextGadget(txt_recipes,0,0,0,0,"Recipe")
TextGadget(txt_datapack,0,0,0,0,"DataPack")

ContainerGadget(bar_advanced,0,0,0,0,#PB_Container_Single)
CloseGadgetList()
ContainerGadget(bar_datapack,0,0,0,0,#PB_Container_Single)
CloseGadgetList()
ContainerGadget(bar_recipes,0,0,0,0,#PB_Container_Single)
CloseGadgetList()
ContainerGadget(bar_vanilla,0,0,0,0,#PB_Container_Single)
CloseGadgetList()


ComboBoxGadget(cbx_category,0,0,0,0)
StringGadget(str_FindItem,0,0,0,0,"")
ButtonGadget(btn_ClearFindItem,0,0,0,0,"X")
canlist::Gadget(cls_items,0,0,10,10)
canlist::SetEvent(cls_items,cls_items)

OptionGadget(opt_shaped,0,0,0,0,"Shaped")
OptionGadget(opt_shapeless,0,0,0,0,"Shapeless")
OptionGadget(opt_smelting,0,0,0,0,"Smelting")

TextGadget(txt_Group,0,0,0,0,"Group:")
StringGadget(str_Group,0,0,0,0,"")

CanvasGadget(can_Grid,0,0,0,0)

TextGadget(txt_Result,0,0,0,0,"Result:")
CanvasGadget(can_Result,0,0,0,0)

TextGadget(txt_count,0,0,0,0," x ")
SpinGadget(spn_count,0,0,0,0,1,999,#PB_Spin_Numeric)

TextGadget(txt_experience,0,0,0,0,"Experience")
StringGadget(str_experience,0,0,0,0,"")

TextGadget(txt_cookingtime,0,0,0,0,"Cooking time")
StringGadget(str_cookingtime,0,0,0,0,"")

CheckBoxGadget(chk_Trigger,0,0,0,0,"Trigger item:")
CanvasGadget(can_Trigger,0,0,0,0)

canlist::Gadget(cls_CostumRecipes,0,0,10,10)
canlist::SetEvent(cls_costumrecipes,cls_costumrecipes)

TextGadget(txt_namespace,0,0,0,0,"Namespace")
StringGadget(str_namespace,0,0,0,0,LCase(GetRandomName()))

TextGadget(txt_title,0,0,0,0,"Title")
StringGadget(str_title,0,0,0,0,LCase("created with "+#title))


SetGadgetText(spn_count,"1")
SetGadgetState(opt_shaped,#True)

FillCategory()
SetGadgetState(cbx_category,1)
FillItems()
FillCostumRecipe()
win_sizeWindow()

ClearRecipe()

AddWindowTimer(win,#tim_circleIcon,1000)

HideWindow(win,#False,#PB_Window_ScreenCentered)

Repeat
  Select WaitWindowEvent()
    Case #PB_Event_Timer      
      Select EventTimer()
        Case #tim_statusbar
          StatusBarText(sbr_win,0,"")
          RemoveWindowTimer(win,#tim_statusbar)
          
        Case #tim_circleIcon
          grid_circle+1
          If grid_circle<0
            grid_circle=0
          EndIf
      EndSelect
      can_Grid_draw()
      can_Result_draw()
      can_Trigger_draw()
      
    Case #PB_Event_Menu
    Case #PB_Event_Gadget
      checkRecipe()
          
    Case #PB_Event_CloseWindow
      Break
  EndSelect
ForEver

  



; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 19
; Folding = v---------
; EnableXP
; UseIcon = knowledge_book.ico
; Executable = work\CreateRecipe.exe